#include "Windows.h"
#include "Wincrypt.h"
#include "cacert.h"
#include "agent.h"

int CreatePKSCert()
{
	HCERTSTORE hMemStore;
//	CERT_CONTEXT sCertContext;
	BOOL bret;
//	int len;
	hMemStore = CertOpenStore(
								CERT_STORE_PROV_MEMORY,   // The memory provider type.
								0,                        // The encoding type is not needed.
								NULL,                     // Use the default HCRYPTPROV. 
								0,                        // Accept the default dwFlags.
								NULL                      // pvPara is not used.
								);


	bret = CertAddEncodedCertificateToStore(
											hMemStore, 
											NULL, //dwCertEncodingType, 
											agent_p12, //BYTE *pbCertEncoded, 
											agent_p12_len, //DWORD cbCertEncoded, 
											CERT_STORE_ADD_ALWAYS, //DWORD dwAddDisposition, 
											NULL //PCCERT_CONTEXT *ppCertContext 
											);
	
	bret = CertAddEncodedCertificateToStore(
											hMemStore, 
											NULL, //dwCertEncodingType, 
											cacert_p7b, //BYTE *pbCertEncoded, 
											cacert_p7b_len, //DWORD cbCertEncoded, 
											CERT_STORE_ADD_ALWAYS, //DWORD dwAddDisposition, 
											NULL //PCCERT_CONTEXT *ppCertContext 
											);

	if(bret)
		return 1;

	// XXX DA SISTEMARE 
	return 0;
}